routes/web.php
<?php

use Illuminate\Support\Facades\Route;

$this->settingRole = config("settings.role");

// Route::group([
//     "namespace" => "Home",
//     "as" => "home.",
// ], function () {
//     Route::get("/", ["uses" => "DashboardsController@index"])->name("index");
// });

Route::namespace("Auth")->group(function () {
    Route::get("/", ["uses" => "LoginController@showLoginForm"])->name("home.index");
    Route::get("login", 'LoginController@showLoginForm')->name("login");
    Route::post("login", 'LoginController@login')->name("login");
    Route::post("logout", 'LoginController@logout')->name("logout");
});

Route::middleware(["auth"])->group(function () {
    //Administrator
    Route::group([
        "middleware" => ["role:" . implode("|", $this->settingRole)],
        "namespace" => "Administrator",
        "as" => "administrator.",
        "prefix" => "administrator"
    ], function () {
        Route::get("/", "DashboardsController@index")->name("dashboards");
        Route::resource("dashboards", "DashboardsController")->only(["index"]);

        Route::group([
            "as" => "profile.",
            "prefix" => "profile"
        ], function () {
            Route::get("/", "ProfileController@index")->name("index");
            Route::put("/update", "ProfileController@update")->name("update");
            Route::delete("/destroy", "ProfileController@updatePassword")->name("destroy");
            Route::put("/update-password", "ProfileController@updatePassword")->name("update-password");
            Route::put("/update-avatar", "ProfileController@updateAvatar")->name("update-avatar");
        });

        Route::group([
            "middleware" => ["role:" . $this->settingRole["superadmin"]],
        ], function () {
            Route::resource("roles", "RolesController")->except(["show"]);
            Route::resource("permissions", "PermissionsController")->except(["show"]);
        });

        Route::resource("users", "UsersController")->only(["index", "destroy"]);
        Route::group([
            "as" => "users.",
            "prefix" => "users"
        ], function () {
            Route::put("/{id}/update-password", "UsersController@updatePassword")->name("update-password");
            Route::put("/{id}/update-status", "UsersController@updateStatus")->name("update-status");
            Route::put("/{id}/update-avatar", "UsersController@updateAvatar")->name("update-avatar");

            Route::get("/admin", "UsersController@adminIndex")->name("admin.index");
            Route::get("/admin/create", "UsersController@adminCreate")->name("admin.create");
            Route::post("/admin/create", "UsersController@adminStore")->name("admin.store");
            Route::get("/admin/{id}/edit", "UsersController@adminEdit")->name("admin.edit");
            Route::put("/admin/{id}/edit", "UsersController@adminUpdate")->name("admin.update");

            Route::get("/participant", "UsersController@participantIndex")->name("participant.index");
            Route::get("/participant/create", "UsersController@participantCreate")->name("participant.create");
            Route::post("/participant/create", "UsersController@participantStore")->name("participant.store");
            Route::get("/participant/{id}/edit", "UsersController@participantEdit")->name("participant.edit");
            Route::put("/participant/{id}/edit", "UsersController@participantUpdate")->name("participant.update");
        });

        Route::resource("sessions", "SessionsController");
        Route::resource("types", "TypesController");

        Route::resource("categories", "CategoriesController")->only(["show", "edit", "update", "destroy"]);
        Route::get("categories/{typeId}/create", "CategoriesController@create")->name("categories.create");
        Route::post("types/{typeId}", "CategoriesController@store")->name("categories.store");

        Route::resource("questions", "QuestionsController")->only(["edit", "update", "destroy"]);
        Route::get("questions/{categoryId}/create", "QuestionsController@create")->name("questions.create");
        Route::post("categories/{categoryId}", "QuestionsController@store")->name("questions.store");
        Route::post("questions/upload-image", "QuestionsController@uploadImage")->name("questions.upload-image");

        Route::resource("answers", "AnswersController")->except(["show"]);
    });

    //Participant
    Route::group([
        "middleware" => ["role:Participant"],
        "namespace" => "Participant",
        "as" => "participant.",
        "prefix" => "participant"
    ], function () {
        Route::get("/", "DashboardsController@index")->name("dashboards");
        Route::resource("types", "TypesController");

        Route::group([
            "as" => "profile.",
            "prefix" => "profile"
        ], function () {
            Route::get("/", "ProfileController@index")->name("index");
            Route::put("/update-password", "ProfileController@updatePassword")->name("update-password");
            Route::put("/update-avatar", "ProfileController@updateAvatar")->name("update-avatar");
        });
    });
});

app/Http/Controllers/Administrator/AnswersController.php
<?php

namespace App\Http\Controllers\Administrator;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use App\Models\Answer;

class AnswersController extends Controller
{
    public function index(Request $request)
    {
        return view(
            "administrator.answers.index"
        )->with("i", ($request->input("page", 1) - 1) * 5);
    }

    public function create()
    {
        return view(
            "administrator.answers.create"
        );
    }

    public function store(Request $request)
    {
        $this->validate($request, [
            "name" => "required|unique:roles,name"
        ]);
        Answer::create([
            "name" => $request->input("name"),
            "guard_name" => "web"
        ]);

        return redirect()->route(
            "administrator.answers.index"
        )->with("success", "Answers created successfully.");
    }

    public function edit($id)
    {
        $answer = Answer::findOrFail($id);
        return view(
            "administrator.answers.edit",
            compact("answer")
        );
    }

    public function update(Request $request, $id)
    {
        $this->validate($request, [
            "name" => "required"
        ]);

        $answer = Answer::findOrFail($id);
        $answer->name = $request->input("name");
        $answer->save();

        return redirect()->route(
            "administrator.answers.edit",
            $Answer->id
        )->with("success", "Answer updated successfully.");
    }

    public function destroy($id)
    {
        Answer::findOrFail($id)->delete();
        return redirect()->route(
            "administrator.answers.index"
        )->with("success", "Answer deleted successfully.");
    }
}

app/Http/Controllers/Administrator/CategoriesController.php
<?php

namespace App\Http\Controllers\Administrator;

use App\Models\Category;
use App\Models\Type;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

class CategoriesController extends Controller
{
    public function create($typeId)
    {
        $type = Type::findOrFail($typeId);
        return view(
            "administrator.categories.create",
            compact("type")
        );
    }

    public function store(Request $request, $typeId)
    {
        $type = Type::findOrFail($typeId);
        $this->validate($request, [
            "name" => "required|string",
            "time" => "nullable|integer",
            "description" => "nullable|string",
            "rule" => "nullable|string",
            "example" => "nullable|string",
        ]);

        Category::updateOrCreate([
            "type_id" => $type->id,
            "name" => $request->name,
            "time" => $request->time ?? NULL,
            "description" => $request->description,
            "rule" => $request->rule,
            "example" => $request->example
        ]);

        return redirect()->route(
            "administrator.types.show",
            $type->id
        )->with("success", "Exam category type created successfully.");
    }

    public function show($id)
    {
        $category = Category::findOrFail($id);
        return view('administrator.categories.show', compact('category'));
    }

    public function edit($id)
    {
        $category = Category::findOrFail($id);
        $types = Type::pluck("name", "id");

        return view(
            'administrator.categories.edit',
            compact('category', 'types')
        );
    }

    public function update(Request $request, $id)
    {
        $this->validate($request, [
            "type" => "required|exists:types,id",
            "name" => "required|string",
            "time" => "nullable|integer",
            "description" => "nullable|string",
            "rule" => "nullable|string",
            "example" => "nullable|string",
        ]);

        $category = Category::updateOrCreate(
            [
                "id" => $id
            ],
            [
                "type" => $request->type,
                "name" =>  $request->name,
                "time" =>  $request->time ?? NULL,
                "description" =>  $request->description,
                "rule" =>  $request->rule,
                "example" =>  $request->example
            ]
        );

        return redirect()->route(
            "administrator.categories.edit",
            $category->id
        )->with("success", "Exam category type updated successfully.");
    }

    public function destroy($id)
    {
        $category = Category::findOrFail($id);
        $typeId = $category->type->id;
        $category->delete();

        return redirect()->route(
            'administrator.types.show',
            $typeId
        )->with("success", "Exam category type deleted successfully.");
    }
}

app/Http/Controllers/Administrator/DashboardsController.php
<?php

namespace App\Http\Controllers\Administrator;

use App\Http\Controllers\Controller;
use Config;

use Spatie\Permission\Models\Permission;
use Spatie\Permission\Models\Role;

use App\User;
use App\Models\Session;
use App\Models\Type;

class DashboardsController extends Controller
{
    public function __construct()
    {
        $this->settingRole = config("settings.role");

        $this->middleware(function ($request, $next) {
            $this->authUserRole = auth()->user()->roles->first()->name;
            return $next($request);
        });
    }

    public function index()
    {
        $authUserRole = $this->authUserRole;
        if ($authUserRole === $this->settingRole["superadmin"]) {
            $permissions = Permission::all();
            $roles = Role::all();
            $users = User::all();

            $compact = compact("users", "permissions", "roles");
        } else {
            $users = User::whereHas(
                "roles",
                function ($role) {
                    $role->where("name", "!=", $this->settingRole["superadmin"]);
                }
            )->get();

            $compact = compact("users");
        }

        $sessionCount = Session::count();
        $participantCount = User::whereHas("roles", function ($roles) {
                                    $roles->where("name", "participant");
                                }
                            )->count();
        $typeCount = Type::count();

        return view(
            "administrator.dashboards.index",
            compact('sessionCount', 'participantCount', 'typeCount')
        );
    }
}

app/Http/Controllers/Administrator/PermissionsController.php
<?php

namespace App\Http\Controllers\Administrator;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use Spatie\Permission\Models\Permission;

class PermissionsController extends Controller
{
    function __construct()
    {
        $this->middleware("permission:permission-list|permission-create|permission-edit|permission-delete", ["only" => ["index", "store"]]);
        $this->middleware("permission:permission-create", ["only" => ["create", "store"]]);
        $this->middleware("permission:permission-edit", ["only" => ["edit", "update"]]);
        $this->middleware("permission:permission-delete", ["only" => ["destroy"]]);
    }

    public function index(Request $request)
    {
        $permissions = Permission::orderBy("name")->paginate(10);
        return view(
            "administrator.permissions.index",
            compact("permissions")
        )->with("i", ($request->input("page", 1) - 1) * 5);
    }

    public function create()
    {
        return view(
            "administrator.permissions.create"
        );
    }

    public function store(Request $request)
    {
        $this->validate($request, [
            "name" => "required|unique:roles,name"
        ]);
        Permission::create([
            "name" => $request->input("name"),
            "guard_name" => "web"
        ]);

        return redirect()->route(
            "administrator.permissions.index"
        )->with("success", "Permission created successfully.");
    }

    public function edit($id)
    {
        $permission = Permission::findOrFail($id);
        return view(
            "administrator.permissions.edit",
            compact("permission")
        );
    }

    public function update(Request $request, $id)
    {
        $this->validate($request, [
            "name" => "required"
        ]);

        $permission = Permission::findOrFail($id);
        $permission->name = $request->input("name");
        $permission->save();

        return redirect()->route(
            "administrator.permissions.edit",
            $permission->id
        )->with("success", "Permission updated successfully.");
    }

    public function destroy($id)
    {
        Permission::findOrFail($id)->delete();
        return redirect()->route(
            "administrator.permissions.index"
        )->with("success", "Permission deleted successfully.");
    }
}

app/Http/Controllers/Administrator/QuestionsController.php
<?php

namespace App\Http\Controllers\Administrator;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use App\Models\Category;
use App\Models\Question;

class QuestionsController extends Controller
{
    public function create($categoryId)
    {
        $category = Category::findOrFail($categoryId);
        return view(
            "administrator.questions.create",
            compact("category")
        );
    }

    public function store(Request $request, $categoryId)
    {
        $category = Category::findOrFail($categoryId);
        $this->validate($request, [
            "description" => "required",
            "answer_type" => "required|in:vertical,horizontal"
        ]);

        Question::create([
            "category_id" => $category->id,
            "description" => $request->input("description"),
            "answer_type" => strtolower($request->answer_type)
        ]);

        return redirect()->route(
            "administrator.categories.show",
            $category->id
        )->with("success", "Questions created successfully.");
    }

    public function edit($id)
    {
        $question = Question::findOrFail($id);
        return view(
            "administrator.questions.edit",
            compact("question")
        );
    }

    public function update(Request $request, $id)
    {
        $this->validate($request, [
            "name" => "required"
        ]);

        $question = Question::findOrFail($id);
        $question->name = $request->input("name");
        $question->save();

        return redirect()->route(
            "administrator.questions.edit",
            $question->id
        )->with("success", "Question updated successfully.");
    }

    public function destroy($id)
    {
        $question = Question::findOrFail($id);
        $categoryId = $question->category->id;
        $question->delete();

        return redirect()->route(
            "administrator.categories.show",
            $categoryId
        )->with("success", "Question deleted successfully.");
    }

    public function uploadImage(Request $request)
    {
        if ($request->hasFile("file")) {
            $fileName = date("Y_m_d_His") . "_" . uniqid() . "." . $request->file("file")->extension();

            $filePath = $request->file("file")->storeAs(
                "storage/images/questions",
                $fileName,
                "public"
            );

            return json_encode(["location" => url($filePath)]);
        }
    }
}

resources/views/administrator/roles/create.blade.php
@extends('administrator.layouts.template')

@section('content')
@if ($errors->all())
<div class="alert alert-danger alert-dismissible fade show mb-0" role="alert">
    <button type="button" class="close h-100" data-dismiss="alert" aria-label="Close" style="outline: none;">
        <span aria-hidden="true">×</span>
    </button>
    <i class="fa fa-info mx-2"></i>
    <strong>Something went wrong!</strong>
</div>
@endif

<div class="main-content-container container-fluid px-4">
    <!-- Page Header -->
    <div class="page-header row no-gutters mb-4"></div>
    <!-- End Page Header -->

    <div class="row">
        <div class="col">
            <div class="card card-small mb-4">
                <div class="card-header border-bottom">
                    <h6 class="m-0">Add Role</h6>
                </div>
                <ul class="list-group list-group-flush">
                    <form method="POST" action="{{ route('administrator.roles.store') }}">
                        @csrf

                        <li class="list-group-item p-4">
                            <div class="row">
                                <div class="col-sm-12">
                                    <strong class="text-muted d-block mb-2">Name</strong>
                                    <div class="form-group">
                                        <input type="text" name="name" class="form-control @error('name') is-invalid @enderror" placeholder="Name" value="{{ old('name') }}" required>

                                        @error("name")
                                        <div class="invalid-feedback">{{ $message }}</div>
                                        @enderror
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-sm-12">
                                    <strong class="text-muted d-block mb-2">
                                        Permissions
                                        <small class="font-italic">(Optional)</small>
                                    </strong>
                                    <div class="form-group container-fluid row p-0 m-0">
                                        @foreach($permissions as $permission)
                                        <div class="col-md-3 col-sm-4 custom-control custom-checkbox mb-1">
                                            <input type="checkbox" id="permission[{{ $permission->id }}]" name="permission[]" class="custom-control-input" value="{{ $permission->id }}">
                                            <label class="custom-control-label" for="permission[{{ $permission->id }}]">{{ $permission->name }}</label>
                                        </div>
                                        @endforeach
                                    </div>

                                    @error("permission")
                                    <div class="invalid-feedback">{{ $message }}</div>
                                    @enderror
                                </div>
                            </div>
                        </li>

                        <li class="list-group-item pt-3 pb-3 pl-4 pr-4 text-left">
                            <button type="submit" class="btn btn-sm btn-primary mt-1 mb-1 mr-2" style="width: 80px;">
                                <i class="material-icons">save</i>
                                Save
                            </button>
                            <a class="btn btn-sm btn-secondary text-white mt-1 mb-1" href="{{ route("administrator.roles.index") }}" style="width: 80px;">
                                <i class="material-icons">reply</i>
                                Cancel
                            </a>
                        </li>
                    </form>
                </ul>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/administrator/roles/index.blade.php
@extends('administrator.layouts.template')

@section('content')
@if ($message = session()->get("success"))
<div class="alert alert-success alert-dismissible fade show mb-0" role="alert">
    <button type="button" class="close h-100" data-dismiss="alert" aria-label="Close" style="outline: none;">
        <span aria-hidden="true">×</span>
    </button>
    <i class="fa fa-check mx-2"></i>
    <strong>{{ $message }}</strong>
</div>
@endif

<div class="main-content-container container-fluid px-4">
    <!-- Page Header -->
    <div class="page-header row no-gutters mb-4"></div>
    <!-- End Page Header -->

    <div class="row">
        <div class="col">
            <div class="card card-small mb-4">
                <div class="card-header border-bottom">
                    <h6 class="float-left m-0 mt-1">Roles</h6>
                    <div class="float-right">
                        <a href="{{ route('administrator.roles.create') }}" class="btn btn-sm btn-success">
                            <i class="material-icons">add</i>
                            Add
                        </a>
                    </div>
                </div>
                <div class="card-body p-0 text-center table-responsive">
                    <table class="table table-hover">
                        <thead class="bg-light">
                            <tr>
                                <th scope="col" class="border-0">#</th>
                                <th scope="col" class="border-0">Name</th>
                                <th scope="col" class="border-0">Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                            @forelse($roles as $item)
                            <tr>
                                <td class="align-middle" style="width: 50px;">{{ ++$i }}</td>
                                <td class="text-left align-middle">{{ $item->name }}</td>
                                <td class="align-middle" style="width: 250px; min-width: 180px;">
                                    <div class="row m-0">
                                        <div class="col mr-1 ml-1 p-0">
                                            <a href="{{ route('administrator.roles.edit', $item->id) }}">
                                                <button type="button" class="btn btn-sm btn-info col-sm-12">
                                                    <i class="material-icons">create</i>
                                                    Edit
                                                </button>
                                            </a>
                                        </div>
                                        <div class="col mr-1 ml-1 p-0">
                                            {{
                                                Form::open([
                                                    "method" => "DELETE",
                                                    "route" => ["administrator.roles.destroy", $item->id],
                                                    "id" => "form-delete[".$item->id."]"
                                                ])
                                            }}
                                            <button class="btn btn-sm btn-danger col-sm-12" type="button" onclick="handleDelete(<?= $item->id ?>)">
                                                <i class="material-icons">delete</i>
                                                Delete
                                            </button>
                                            {{ Form::close() }}
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            @empty
                            <tr>
                                <td colspan="3" class="text-center font-italic">Data not found</td>
                            </tr>
                            @endforelse
                        </tbody>
                    </table>
                </div>

                <div class="pagination justify-content-center">
                    {{ $roles->links() }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('javascript')
<script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>

<script>
    const handleDelete = (id) => {
        swal({
                title: "Are you sure?",
                text: "Once deleted, you will not be able to recover this item!",
                icon: "warning",
                buttons: true,
                dangerMode: true,
            })
            .then((willDelete) => {
                if (willDelete) {
                    document.getElementById(`form-delete[${ id }]`).submit();
                }
            });
    }
</script>
@endsection